#!/usr/bin/env python
# -*- coding: utf-8 -*-

# # Javascript library in a notebook: viz.js
# 
# Tries [vizjs](https://github.com/mdaines/viz.js/) in a notebook. This is a simple way to show a graph defined with the [DOT language](http://www.graphviz.org/content/dot-language/). [vizjs](https://github.com/mdaines/viz.js/) compiles [Graphviz](https://www.graphviz.org/) was compiled into javascript with [emscripten](http://kripken.github.io/emscripten-site/).

# In[1]:


from jyquickhelper import add_notebook_menu
add_notebook_menu()


# ## viz.js

# In[2]:


from jyquickhelper import RenderJS
css = None
libs = ['http://www.xavierdupre.fr/js/vizjs/viz-lite.js']
script = """
var svgGraph = Viz("digraph { a -> b; }");
document.getElementById('__ID__').innerHTML = svgGraph;
"""
jr = RenderJS(script, css=css, libs=libs)
jr


# In[3]:


print(jr._repr_html_())


# ## wrapped into RenderJsDot
# 
# The previous script was wraps into a class in this module.

# In[4]:


from jyquickhelper import RenderJsDot

dot = """
digraph {
    d[label="longer label"];
    a -> b -> c;
    b -> d;
}
"""

RenderJsDot(dot)


# In[5]:


print(RenderJsDot(dot)._repr_html_())


# ## d3 graphviz

# The graph can become dynamic by using [d3-graphviz](https://github.com/magjac/d3-graphviz). I took the minified version available here [d3-graphviz.min.js](https://www.jsdelivr.com/package/npm/d3-graphviz) showing up at this example [d3-graphviz Basic Example](https://bl.ocks.org/magjac/a23d1f1405c2334f288a9cca4c0ef05b).

# In[6]:


css = None
libs = [dict(path="http://www.xavierdupre.fr/js/d3/d3.v4.min.js",
             name="d3", exports="d3"),
        'http://www.xavierdupre.fr/js/vizjs/viz-lite.js',
        'http://www.xavierdupre.fr/js/d3graphviz/d3-graphviz.min.js']
script = """
d3.select("#__ID__").graphviz()
    .fade(false)
    .renderDot('digraph  {a -> b}');
"""
jr = RenderJS(script, css=css, libs=libs)
jr


# In[7]:


print(jr._repr_html_())


# Not really working.

# In[8]: